// ************************************
// 
// V-SERVO TvvO1
// 
// sample1.c
// 
// 
// [^𓮂
// 
// ************************************

#include <windows.h>
#include <stdio.h>
#include <math.h>


#define  COMPORT  "COM3"                                     // COM|[gݒ
#define  SID  0x00                                           // IDݒ

/* vg^Cv */
HANDLE CreateFile_port(LPCTSTR, DWORD, DWORD, LPSECURITY_ATTRIBUTES, DWORD, DWORD, HANDLE);
HANDLE serial_open(char *, DWORD, DWORD);
void serial_close(HANDLE);

/* C֐ */
int main(int argc, char *argv[])
{
  HANDLE hCom=(HANDLE)-1;
  int sid = SID;

  hCom = serial_open(COMPORT, CBR_115200, 10);
  if(hCom == (HANDLE)-1) {
    fprintf(stderr,"serial_open\n");
    exit(1);
  }

  while(hCom>=0) {
    BYTE buf[256];
    DWORD bytes;
    int cmd;

    // AbN
    buf[0] = 0x80 | SID;
    buf[1] = 0x40 | 0x00 | 1;                                // write 1byte
    buf[2] = 0x14;                                           // SYS_ULK
    buf[3] = 0x55;
    WriteFile(hCom, buf, 3+1, &bytes, NULL);

    // j[ʕ\
    printf("SID:%02x PORT:%s\n", SID, COMPORT);
    printf("  1 .. [^ON\n"
     "  2 .. [^OFF\n"
     "  3 .. 0x400Ɉړ\n"
     "  4 .. 0x800Ɉړ\n"
     "  5 .. XCO\n"
     "  9 .. I\n"
     ">");
    fflush(stdout);

    fgets(buf, 256, stdin);
    cmd = atoi(buf);
    switch(cmd) {

    // T[{IEIt
    case 1:
    case 2:
      buf[0] = 0x80 | SID;
      buf[1] = 0x40 | 0x00 | 1;                              // write 1byte
      buf[2] = 0x3b;                                         // PWM_EN
      buf[3] = (cmd==1) ? 1 : 0;
      WriteFile(hCom, buf, 3+1, &bytes, NULL);
      break;

    // ڕWlݒ
    case 3:
    case 4:
      buf[0] = 0x80 | SID;
      buf[1] = 0x40 | 0x00 | 2;                              // write 2byte
      buf[2] = 0x30;                                         // FB_TPOS
      buf[3] = 0x00;                                         // low  byte
      buf[4] = (cmd==3) ? (0x400>>7) : (0x800>>7);           // high byte
      WriteFile(hCom, buf, 3+2, &bytes, NULL);
      break;

    // XCO
    // o[Xg[hSID=0SID=29܂ł𓯎ɑ
    case 5:
    {
      int t;
      for(t=0; t<300; t++) {
        int tpos = (int)(0x800 + 0x400 * sin(3.1416*2*t/50));
        int k = 0, i;
        // 30̎w+syncobt@āAxɏ
        for(i=0; i<30; i++) {
          buf[k++] = 0xc0 | i;                               // burst
          buf[k++] = (tpos>>0) & 0x7f;
          buf[k++] = (tpos>>7) & 0x7f;
          buf[k++] = 1;
          buf[k++] = 0;
        }
        buf[k++] = 0x80 | 0x3f;                              // write broadcast
        buf[k++] = 0x40 | 1;
        buf[k++] = 0x4f;
        buf[k++] = 1;

        WriteFile(hCom, buf, k, &bytes, NULL);
        Sleep(20);
      }
    }
    break;

    case 9:
      serial_close(hCom);
      exit(0);
      break;
    }
  }
  return 1;
}

/* VA֐ */
HANDLE CreateFile_port(LPCTSTR lpFileName,                   // pointer to name of the file
        DWORD dwDesiredAccess,                               // access (read-write) mode
        DWORD dwShareMode,                                   // share mode
        LPSECURITY_ATTRIBUTES lpSecurityAttributes,          // pointer to security attributes
        DWORD dwCreationDisposition,                         // how to create
        DWORD dwFlagsAndAttributes,                          // file attributes
        HANDLE hTemplateFile)                                //handle to file with attributes to copy
{
  char buf[1024];
  sprintf(buf, "\\\\.\\%s", lpFileName);
  return CreateFile(buf,
        dwDesiredAccess,                                     // access (read-write) mode
        dwShareMode,                                         // share mode
        lpSecurityAttributes,                                // pointer to security attributes
        dwCreationDisposition,                               // how to create
        dwFlagsAndAttributes,                                // file attributes
        hTemplateFile);                                      //handle to file with attributes to copy
}

HANDLE serial_open(char *portname, DWORD BaudRate, DWORD timeout)
{
  HANDLE hCom;
  DCB    stDcb;
  
  if((hCom = CreateFile_port(portname, GENERIC_READ | GENERIC_WRITE,
           0,                                                // exclusive access
           NULL,                                             // no security attrs
           OPEN_EXISTING,
           FILE_ATTRIBUTE_NORMAL |FILE_FLAG_WRITE_THROUGH,
           NULL)
      )==(HANDLE)-1) {
      fprintf(stderr,"cannot open");
    return (HANDLE)-1;
  }
    
  if(GetCommState(hCom,&stDcb)==FALSE){
      fprintf(stderr,"err in GetCommState()");
    return (HANDLE)-1;
  }
  stDcb.BaudRate=BaudRate;
  stDcb.fBinary=1;
  stDcb.fParity=0;
  stDcb.fOutxCtsFlow=0;
  stDcb.fOutxDsrFlow=0;
  stDcb.fDtrControl=DTR_CONTROL_HANDSHAKE;
  stDcb.fDsrSensitivity=0;
  stDcb.fTXContinueOnXoff=0;
  stDcb.fOutX=0;
  stDcb.fInX=0;
  stDcb.fErrorChar=0;
  stDcb.fNull=0;
  stDcb.fRtsControl=RTS_CONTROL_ENABLE;
  stDcb.fAbortOnError=0;
  stDcb.ByteSize=8;
  stDcb.Parity=NOPARITY;
  stDcb.StopBits=ONESTOPBIT;
  stDcb.EofChar=0;
  if(SetCommState(hCom,&stDcb)==FALSE){
      fprintf(stderr,"err in SetCommState()");
    CloseHandle(hCom);
    return (HANDLE)-1;
  }

  {
    COMMTIMEOUTS cto;
    cto.ReadIntervalTimeout         = timeout;               // msec 
    cto.ReadTotalTimeoutMultiplier  = timeout;               // msec 
    cto.ReadTotalTimeoutConstant    = timeout;               // msec 
    cto.WriteTotalTimeoutMultiplier = 0;                     // not used 
    cto.WriteTotalTimeoutConstant   = 0;                     // not used 
    
    if(SetCommTimeouts(hCom,&cto)==FALSE) {
      fprintf(stderr,"err in SetCommTimeouts()");
      CloseHandle(hCom);
      return (HANDLE)-1;
    }
  }
  
  return hCom;
}

void serial_close(HANDLE hCom)
{
  if(hCom && hCom!=(HANDLE)-1) {
    CloseHandle(hCom);
  }
}

